/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the CaptchaResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CaptchaResponse{}

// CaptchaResponse struct for CaptchaResponse
type CaptchaResponse struct {
	Success *bool `json:"success,omitempty"`
}

// NewCaptchaResponse instantiates a new CaptchaResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCaptchaResponse() *CaptchaResponse {
	this := CaptchaResponse{}
	return &this
}

// NewCaptchaResponseWithDefaults instantiates a new CaptchaResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCaptchaResponseWithDefaults() *CaptchaResponse {
	this := CaptchaResponse{}
	return &this
}

// GetSuccess returns the Success field value if set, zero value otherwise.
func (o *CaptchaResponse) GetSuccess() bool {
	if o == nil || IsNil(o.Success) {
		var ret bool
		return ret
	}
	return *o.Success
}

// GetSuccessOk returns a tuple with the Success field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CaptchaResponse) GetSuccessOk() (*bool, bool) {
	if o == nil || IsNil(o.Success) {
		return nil, false
	}
	return o.Success, true
}

// HasSuccess returns a boolean if a field has been set.
func (o *CaptchaResponse) HasSuccess() bool {
	if o != nil && !IsNil(o.Success) {
		return true
	}

	return false
}

// SetSuccess gets a reference to the given bool and assigns it to the Success field.
func (o *CaptchaResponse) SetSuccess(v bool) {
	o.Success = &v
}

func (o CaptchaResponse) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CaptchaResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Success) {
		toSerialize["success"] = o.Success
	}
	return toSerialize, nil
}

type NullableCaptchaResponse struct {
	value *CaptchaResponse
	isSet bool
}

func (v NullableCaptchaResponse) Get() *CaptchaResponse {
	return v.value
}

func (v *NullableCaptchaResponse) Set(val *CaptchaResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableCaptchaResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableCaptchaResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCaptchaResponse(val *CaptchaResponse) *NullableCaptchaResponse {
	return &NullableCaptchaResponse{value: val, isSet: true}
}

func (v NullableCaptchaResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCaptchaResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
